package inf119;

public class BoundBox {
	
	public double[][] top, bottom;
	private double boxWidth, boxHeight;	
	
	public BoundBox(LanderModel lm)
	{
		top = new double[4][3];
		bottom = new double[4][3];
		
		boxWidth = lm.getWidth();		
		boxHeight = lm.getHeight();
//		System.out.println("Box dim: " + boxWidth + "," + boxHeight);
		updateBoxLoc(lm.centMass);		
	}

	//call this function to see if box is at or below groundHeight
	public boolean isColliding(double groundHeight)
	{
		for( int i = 0; i < top.length; i++ )
		{
			if( top[i][1] <= groundHeight ){
				System.out.println("Top = " + top[i][1] + ", ground = " + groundHeight);
				return true;
			}
		}
		for( int j = 0; j < bottom.length; j++ )
		{
			if( bottom[j][1] <= groundHeight ){
				System.out.println("Bottom = " + bottom[j][1] + ", ground = " + groundHeight);
				return true;
			}
		}
		
		return false;
	}
	
	//updates bounding box location based on center point of the lander
	public void updateBoxLoc(double[] centerPoint)
	{
		top[0][0] = centerPoint[0]-boxWidth/2;
		top[0][1] = centerPoint[1]+boxHeight/2;
		top[0][2] = centerPoint[2]-boxWidth/2;
		
		top[1][0] = centerPoint[0]-boxWidth/2;
		top[1][1] = centerPoint[1]+boxHeight/2;
		top[1][2] = centerPoint[2]+boxWidth/2;
		
		top[2][0] = centerPoint[0]+boxWidth/2;
		top[2][1] = centerPoint[1]+boxHeight/2;
		top[2][2] = centerPoint[2]+boxWidth/2;
		
		top[3][0] = centerPoint[0]+boxWidth/2;
		top[3][1] = centerPoint[1]+boxHeight/2;
		top[3][2] = centerPoint[2]-boxWidth/2;
		
		bottom[0][0] = centerPoint[0]-boxWidth/2;
		bottom[0][1] = centerPoint[1]-boxHeight/2;
		bottom[0][2] = centerPoint[2]-boxWidth/2;
		
		bottom[1][0] = centerPoint[0]+boxWidth/2;
		bottom[1][1] = centerPoint[1]-boxHeight/2;
		bottom[1][2] = centerPoint[2]-boxWidth/2;
		
		bottom[2][0] = centerPoint[0]+boxWidth/2;
		bottom[2][1] = centerPoint[1]-boxHeight/2;
		bottom[2][2] = centerPoint[2]+boxWidth/2;
		
		bottom[3][0] = centerPoint[0]-boxWidth/2;
		bottom[3][1] = centerPoint[1]-boxHeight/2;
		bottom[3][2] = centerPoint[2]+boxWidth/2;
	}
}
