package inf119;

/**
 * LocOri.java
 * 
 * Stores location and orientation data
 * Useful for camera info as well as lander info
 * 
 * @author mmasukaw
 */

public class LocOri {
	private double[] pos = {0,0,0};
	private double[] rot = {0,0,0};
	
	public LocOri()
	{
	}
	
	public LocOri(double[] cP, double[] cR)
	{
		setLocOri(cP, cR);
	}
	public LocOri(double[] cPR)
	{
		setLocOri(cPR);
	}
	
	public void setLoc(double[] cP)
	{
		for (int i = 0; i < 3; i++){
			pos[i] = cP[i];
		}
	}
	
	public void setOri(double[] cR)
	{
		for (int i = 0; i < 3; i++){
			rot[i] = cR[i];
		}
	}
	
	public void setLocOri(double[] cP, double[] cR)
	{
		for (int i = 0; i < 3; i++){
			pos[i] = cP[i];
			rot[i] = cR[i];
		}
	}
	public void setLocOri(double[] cPR)
	{
		for (int i = 0; i < 3; i++){
			pos[i] = cPR[i];
			rot[i] = cPR[i+3];
		}
	}	
	public double[] toSingleArray()
	{
		double[] ret = new double[6];
		for (int i = 0; i < 3; i++){
			ret[i] = pos[i];
			ret[i+3] = rot[i];
		}
		return ret;
	}
	
	public String toString()
	{
		String ret = "Location = (" + pos[0] + ", " + pos[1] + ", " + pos[2] + ")"
			+ "\nRotation = (" + rot[0] + ", " + rot[1] + ", " + rot[2] + ")";
		
		return ret;
	}
	
	public double[] getPos()
	{
		double[] ret = new double[3];
		for (int i = 0; i < 3; i++){
			ret[i] = pos[i];
		}
		return ret;
	}
	public double[] getRot()
	{
		double[] ret = new double[3];
		for (int i = 0; i < 3; i++){
			ret[i] = rot[i];
		}
		return ret;
	}
}
