package inf119.LunarLanderLauncher;
/*
 * Lunar_Lander_Launcher.java
 *
 * Version:
 *     1.0
 *
 *
 */

import java.awt.*;

import javax.swing.*;
import java.io.*;
import java.util.*;
import inf119.Constants;
import inf119.interfaces.*;


import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
/**
 * This program produces a conversion table from Celsius to
 * Fahrenheit for values from 0 to 99.  This program appears in
 * "Java Gently" by J M Bishop.
 *
 * @author      Stephen C. Reed
 */
public class LunarLanderLauncher extends JFrame implements ActionListener
{

	//declare input area components
	private String rlabels[] = { "Name:               " ,"Mode:                ", "Spaceship:      ", "Landing Spot: ","Difficulty:            ", " "};

	private String slabels[] = {"Name:               ", "Mode:                ", "Scenario:         ","Difficulty:          ", "High Score:   "};
	private String glabels[] = {"Name:               ", "Mode:                ", "Saved Game:  "};
	private String hlabels[] = {"Lunar Lander Help Menu", 
		 "This lunar landing game is controlled by a keyboard and a mouse. ", 
		 "The controls for this game are:", 
		 " Keyboard Controls:",
		 "Keys A and D, to Yaw (Left/Right)", 
		 "Keys W and S, to Pitch(Up/Down)", 
		 "Keys Q and E, to Roll(Left/Right", 
		 "Mouse Controls : ", 
		 "left click and drag moves the camera around the camera sphere (centered at the ship) ", 
		 "right click and drag up/down: decreases/increases the radius of the camera sphere."};

	private  JTextField userName = new JTextField(15);
  
	private JPanel p;
String labelTextShip = "Default Ship";
String labelLunarLander = "Lunar Lander";
String labelTextPlanet = "Default Planet";
private JLabel pickPlanet=  new JLabel(labelTextPlanet,
        new ImageIcon("bluemoon.jpg"),
        JLabel.CENTER);
private JLabel pickLunarLander=  new JLabel(
        new ImageIcon("lunar_lander.jpg"),
        JLabel.CENTER);
private JLabel pickShip =new JLabel(labelTextShip,
        new ImageIcon("LEM.jpg"),
        JLabel.CENTER);
JLabel picShip= new JLabel(labelTextShip,
               new ImageIcon("LEM.jpg"),
               JLabel.CENTER);
JLabel picPlanet = new JLabel(labelTextPlanet,
        new ImageIcon("bluemoon.jpg"),
        JLabel.CENTER);
private JComboBox spaceShip = new JComboBox();
private JComboBox mode = new JComboBox();
private JComboBox savegame = new JComboBox();
private JComboBox scenarioChoice = new JComboBox();
private JComboBox landingSpot = new JComboBox();
private JComboBox difficulty = new JComboBox();
private JTextField highScore = new JTextField(4);
private JTextField siteField = new JTextField(15);
private JTextField descriptionField = new JTextField(15);
 
 
private   JPanel scenarioMain = new JPanel(new BorderLayout());
private JTextField fileField = new JTextField(10);
private  JButton execute = new JButton("Launch");
private JButton help = new JButton("Help");
private  JPanel report = new JPanel(new GridLayout(6,3,2,2));
private  JPanel tempReport = new JPanel(new GridLayout(10,2,2,2));
  //declare button components
private  JButton run = new JButton("Run the Utility");
private   JButton helpReturn = new JButton("Return to Main Screen");
//private   JButton help = new JButton("Helpful Hints");
private   JButton mail = new JButton("Contact Author");
private   JPanel buttons = new JPanel(new GridLayout(4,1,2,2));
  //BorderLayout pane to hold input/button JPanels
private   JPanel main = new JPanel(new BorderLayout());
  
private   ArrayList ships = new ArrayList();
private   ArrayList planets = new ArrayList();
private   ArrayList scenarios = new ArrayList();
private   ArrayList saveGame = new ArrayList();
private StateIntf gsc;
  public LunarLanderLauncher(StateIntf gsc)
  {
	 
	    
    super("Lunar Lander Launcher Menu");
    this.gsc = gsc;
    setBounds(100,100,500,600);
    setDefaultCloseOperation(   EXIT_ON_CLOSE );


    //File dir = new File(".\\.\\");
    File dir = new File(System.getProperty("user.dir"));
  
    String[] children = dir.list();
    if (children == null) {
    	System.out.println("Nothing work");
   
    } else 
    {
    	
    	for (int i=0; i<children.length; i++) {
            // Get filename of file or directory
            String filename = children[i];
        
        }
    }
 
    for (int i = 0; i<children.length; i++)
    {
    	String temp = children[i];
    	if (temp.lastIndexOf(".planet") != -1)
    	{
    		int tempName = temp.lastIndexOf(".planet");
    		String name = temp.substring(0, tempName);
    		
    		planets.add(new planet( name,temp ));
    		
    	}
    	else if(temp.lastIndexOf(".ship")!= -1 && temp.lastIndexOf("model")== -1 )
    	{
    		int tempName = temp.lastIndexOf(".ship");
    		String name = temp.substring(0, tempName);
    		//System.out.println(name);
    		ships.add(new ship( name,temp ));
    		
    	}
    	else if(temp.lastIndexOf(".scenario")!= -1)
    	{
    		int tempName = temp.lastIndexOf(".scenario");
    		String name = temp.substring(0, tempName);
    		scenarios.add(new scenario( name,temp ));
    		
    	}
    	else if(temp.lastIndexOf(".savegame")!= -1)
    	{
    		int tempName = temp.lastIndexOf(".savegame");
    		String name = temp.substring(0, tempName);
    		saveGame.add(new savegame( name,temp ));
    		
    	}
    	
    }
  
    execute.addActionListener(this);
    help.addActionListener(this);
    savegame.addActionListener(this);
    userName.addActionListener(this);
    spaceShip.addActionListener(this);
    mode.addActionListener(this);
     landingSpot.addActionListener(this);
     difficulty.addActionListener(this);
    highScore.addActionListener(this);
    helpReturn.addActionListener(this);
    scenarioChoice.addActionListener(this);

    spaceShip.addItem("Please Select One");
    for (int i =0; i< ships.size(); i++)
    {
    	ship tempShip =(ship) ships.get(i);
    	spaceShip.addItem(tempShip.getName());
    	
    }
    for(int i =0; i< ships.size(); i++)
    {
    	ship tempShip = (ship) ships.get(i);
    	String tempFile = tempShip.getFileName();
    	
    	
    }
    savegame.addItem("Please Select One");
    for (int i =0; i< saveGame.size(); i++)
    {
    	savegame tempShip =(savegame) saveGame.get(i);
    	savegame.addItem(tempShip.getName());
    	
    	
    }
    landingSpot.addItem("Please Select One");
    for (int i =0; i< planets.size(); i++)
    {
    	planet tempPlanet =(planet) planets.get(i);
    	landingSpot.addItem(tempPlanet.getName());
    	
    	

    }
    for (int i =0; i< scenarios.size(); i++)
    {
    	scenario tempShip =(scenario) scenarios.get(i);
    	scenarioChoice.addItem(tempShip.getName());
    	
    	
    }
    mode.addItem("Please Select One");
    mode.addItem("Training Mode");
    mode.addItem("Scenario Mode");
    mode.addItem("Load Game" );
  
    difficulty.addItem("Please Select One");
     difficulty.addItem("Easy");
     difficulty.addItem("Medium");
     difficulty.addItem("Hard");
    
    

     for (int i=0; i<6;i++) 
     {
	      JLabel lab = new JLabel(rlabels[i]);
	      lab.setForeground(Color.black);
	       p = new JPanel(new FlowLayout(FlowLayout.LEFT) );
	     
	      p.add(lab);
	      switch (i) {
	        case 0:
	        	
	        	p.add(userName);
	        	  
	        
	        break;
	        case 1: p.add(mode); 
	        break;
	        case 2: p.add(spaceShip);p.add(picShip);
	       
	        
	        break;
	        case 3: p.add(landingSpot);p.add(picPlanet);
	        break;
	        case 4: p.add(difficulty);
	        break;
	        case 5:
	        p.add(execute);
	        p.add(help);
	        p.add(pickLunarLander);
	        break; 
	       
	        }
	      report.add(p);
	  
	    }


	    main.add("Center",report);
	
	    this.getContentPane().add("Center",main);
	    
	    setVisible(true);
  }
	/**
	 * The main program.
	 *
	 * @param    args    command line arguments (ignored)
	 */

public void drawRegular()
{
	   for (int i=0; i<6;i++)
	    {
	      JLabel lab = new JLabel(rlabels[i]);
	      lab.setForeground(Color.black);
	       p = new JPanel(new FlowLayout(FlowLayout.LEFT));
	      p.add(lab);
	      switch (i) {
	        case 0: p.add(userName); 
	        break;
	        case 1: p.add(mode); 
	        break;
	        case 2: p.add(spaceShip); 
	        break;
	        case 3: p.add(landingSpot);
	        break;
	        case 4: p.add(difficulty);
	        break;
	        case 5: 
	        p.add(execute);
	        p.add(help);
	        break; 
	      
	        }
	      report.add(p);
	    }


	    main.add("Center",report);
	    main.add("East",buttons);
	    this.getContentPane().add("Center",main);
	    setVisible(true);
}
public void drawShip(String planetText, String Filename)
{
	
 pickShip= new JLabel(planetText,
	               new ImageIcon(Filename),
	               JLabel.CENTER);
	   for (int i=0; i<6;i++)
	    {
	      JLabel lab = new JLabel(rlabels[i]);
	      lab.setForeground(Color.black);
	       p = new JPanel(new FlowLayout(FlowLayout.LEFT));
	      p.add(lab);
	      switch (i) {
	        case 0: p.add(userName); 
	        break;
	        case 1: p.add(mode); 
	        break;
	        case 2: p.add(spaceShip); 
	        	p.add(pickShip);
	        break;
	        case 3: p.add(landingSpot);
	        	p.add(pickPlanet);
	        break;
	        case 4: p.add(difficulty);
	        break;
	        case 5: 
	        p.add(execute);
	        p.add(help);
	        break; 
	      
	        }
	      report.add(p);
	    }


	    main.add("Center",report);
	    main.add("East",buttons);
	    this.getContentPane().add("Center",main);
	    setVisible(true);
}
public void drawPlanet(String planetText, String Filename)
{

	 pickPlanet= new JLabel(planetText,
	               new ImageIcon(Filename),
	               JLabel.CENTER);
	   for (int i=0; i<6;i++)
	    {
	      JLabel lab = new JLabel(rlabels[i]);
	      lab.setForeground(Color.black);
	       p = new JPanel(new FlowLayout(FlowLayout.LEFT));
	      p.add(lab);
	      switch (i) {
	        case 0: p.add(userName); 
	        break;
	        case 1: p.add(mode); 
	        break;
	        case 2: p.add(spaceShip); 
	      
	        p.add(pickShip);
	        break;
	        case 3: p.add(landingSpot);
	        	p.add(pickPlanet);
	        break;
	        case 4: p.add(difficulty);
	        break;
	        case 5:
	        p.add(execute);
	        p.add(help);
	        break; 
	      
	        }
	      report.add(p);
	    }


	    main.add("Center",report);
	    main.add("East",buttons);
	    this.getContentPane().add("Center",main);
	    setVisible(true);
}
  public void drawScenario()
  {
	
      double highscore = gsc.getHighScore(gsc.getScenarioName());
    		  String temp1 = Double.toString(highscore);
      JLabel newScore= new JLabel(temp1);
	
	  for (int i=0; i<5;i++)
	    {
	      JLabel lab = new JLabel(slabels[i]);
	      lab.setForeground(Color.black);
	      JPanel temp = new JPanel(new FlowLayout(FlowLayout.LEFT));
	      temp.add(lab); switch (i) {
	        case 0:  temp.add(userName); 
	        break;
	        case 1: temp.add(mode);  
	        break;
	        case 2: temp.add(scenarioChoice); 
	        case 3: temp.add(difficulty);
	        temp.add(execute); 
	        temp.add(help);
	        break;
	        case 4: temp.add(newScore);
	        break;
	       
	        }
	      report.add(temp);
	    }


	    main.add("Center",report);
	    main.add("East",buttons);
	    this.getContentPane().add("Center",main);
	    setVisible(true);
  }
  public void drawLoadGame()
  {
	  for (int i=0; i<3;i++)
	    {
	      JLabel lab = new JLabel(glabels[i]);
	      lab.setForeground(Color.black);
	      JPanel p = new JPanel(new FlowLayout(FlowLayout.LEFT));
	      p.add(lab); switch (i) {
	        case 0: p.add(userName); 
	        break;
	        case 1: p.add(mode); 
	        break;
	        case 2: p.add(savegame); 
	        p.add(execute);
	        p.add(help);
	        break;
	     
	     
	        }
	      report.add(p);
	    }


	    main.add("Center",report);
	    main.add("East",buttons);
	    this.getContentPane().add("Center",main);
	    setVisible(true);
  }
  public void drawHelp()
  {
	  for (int i=0; i<10;i++)
	    {
	      JLabel lab = new JLabel(hlabels[i]);
	      lab.setForeground(Color.black);
	      JPanel p = new JPanel(new FlowLayout(FlowLayout.LEFT));
	      p.add(lab); 
	      switch (i) {
	        case 9:  
	        p.add(helpReturn);
	        break;
	     
	      
	        }
	      tempReport.add(p);
	    }


	    main.add("Center",tempReport);
	    main.add("East",buttons);
	    this.getContentPane().add("Center",main);
	    setVisible(true);
  }
  public void actionPerformed(ActionEvent e)
  {   
	  
	  if(e.getSource() == userName)
  		{
	  	String s = userName.getText();
	  	gsc.setCurrentUserName(s);
		}
  	else if(e.getSource() == spaceShip)
  	{
  		String tempFile = spaceShip.getSelectedItem() + ".ship";
  		try
    	{
    		
  			gsc.loadNewShip(tempFile);
  			String picFile = gsc.getShipPictureFileName();
  			//System.out.println(" Pic location " + picFile);
  			main.removeAll();
			report.removeAll();
			tempReport.removeAll();
			p.removeAll();
			repaint();
			drawShip((String)spaceShip.getSelectedItem(), picFile);
  			
    	}
    	catch(FileNotFoundException fnfe)
    	{
    		//System.out.println("File Not Found");
    	}
    	catch(IOException ioe)
    	{
    		System.out.println("IO Exception");
    	}
    	//System.out.println(tempFile);
	
  	}
  	else if(e.getSource() == execute)
  	{
  		try
  		{
  		
  			gsc.launchGame();
  			this.setVisible(false);  			
  			//System.out.println("I'm done");
  		}
  		catch(FileNotFoundException fnfe)
  		{
  			System.out.println("File Not found Exception");
  			
  		}
  		catch (IOException ioe)
  		{
  			System.out.println("IO Exception");
  		}
  	}
  	else if (e.getSource() == savegame)
  	{
  		String tempFile = savegame.getSelectedItem() + ".savegame";
  		try
    	{
    		gsc.loadNewScenario(tempFile);
    	}
    	catch(FileNotFoundException fnfe)
    	{
    		//System.out.println("File Not Found");
    	}
    	catch(IOException ioe)
    	{
    		System.out.println("IO Exception");
    	}
    	//System.out.println(tempFile);
  	}
  	else if (e.getSource() == scenarioChoice)
  	{
  		String tempFile = scenarioChoice.getSelectedItem() + ".scenario";
  		try
    	{
    		gsc.loadNewScenario(tempFile);
  
    	}
    	catch(FileNotFoundException fnfe)
    	{
    		//System.out.println("File Not Found");
    	}
    	catch(IOException ioe)
    	{
    		System.out.println("IO Exception");
    	}
    	//System.out.println(tempFile);
  	}
  	else if(e.getSource()== help)
  	{
  		System.out.println("Help was press");
  		main.removeAll();
		report.removeAll();
		tempReport.removeAll();
		p.removeAll();
		repaint();
		drawHelp();
 	}
	else if(e.getSource()== helpReturn)
  	{
  		
  		main.removeAll();
		report.removeAll();
		tempReport.removeAll();
		p.removeAll();
		repaint();
		drawRegular();
 	}
	else if (e.getSource() == landingSpot)
	{
		String tempFile = landingSpot.getSelectedItem() + ".planet";
		try
		{
			gsc.loadNewPlanet(tempFile);
		}
		catch(IOException e1)
		{
			
		}
		
		String picFile = gsc.getPlanetPictureFileName();
		//System.out.println(landingSpot.getSelectedItem() );
	
		try
    	{
    		//System.out.println("Hello 1");
			gsc.loadNewPlanet(tempFile);
			//System.out.println("Hello 2");
			//String picFile = gsc.getPlanetPictureFileName();
    	
  			//System.out.println(" Pic location " + picFile);
  			main.removeAll();
			report.removeAll();
			tempReport.removeAll();
			p.removeAll();
			repaint();
			drawPlanet((String)landingSpot.getSelectedItem(), picFile);
    	}
    	catch(FileNotFoundException fnfe)
    	{
    		//System.out.println("File Not Found");
    	}
    	catch(IOException ioe)
    	{
    		System.out.println("IO Exception");
    	}
    	//System.out.println(tempFile);
	}
	else if (e.getSource() == difficulty)
	{
		if(difficulty.getSelectedItem().equals("Easy"))
		{
			gsc.setDifficulty(Constants.EASYDIFFICULTY);
		}
		else if (difficulty.getSelectedItem().equals("Medium"))
		{
			gsc.setDifficulty(Constants.NORMALDIFFICULTY);
			
		}
		else{
			
			gsc.setDifficulty(Constants.HARDDIFFICULTY);
		}
		
		//System.out.println( difficulty.getSelectedItem());
	}
	else if (e.getSource() ==  mode)
	{
			if( mode.getSelectedItem().equals("Scenario Mode"))
			{
				gsc.updateMenuState(Constants.SCENARIOMODE);
				main.removeAll();
				report.removeAll();
				tempReport.removeAll();
				p.removeAll();
				repaint();
				try {
					gsc.loadNewScenario("scenario1.scenario");
				} catch (FileNotFoundException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
				drawScenario();
			}
			else if ( mode.getSelectedItem().equals("Training Mode") ||mode.getSelectedItem().equals("") )
			{
				gsc.updateMenuState(Constants.FREEMODE);
				main.removeAll();
				report.removeAll();
				tempReport.removeAll();
				p.removeAll();
				repaint();
				drawRegular();
				
			}
			else if ( mode.getSelectedItem().equals("Load Game"))
			{
				gsc.updateMenuState(Constants.LOADMODE);
				main.removeAll();
				report.removeAll();
				tempReport.removeAll();
				p.removeAll();
				repaint();
				drawLoadGame();
				
			}
			
	}

}
}
