package inf119.graphics;

import java.awt.Font;

import javax.media.opengl.GL;

import com.sun.opengl.util.j2d.TextRenderer;

import edu.uci.isr.myx.fw.AbstractMyxSimpleBrick;
import edu.uci.isr.myx.fw.IMyxName;
import edu.uci.isr.myx.fw.MyxUtils;

import inf119.interfaces.MenuArtistIntf;
import inf119.interfaces.TextureIntf;
import inf119.gamelogic.Menu;
import inf119.gamelogic.MenuItem;

public class MyxMenuArtist extends AbstractMyxSimpleBrick implements MenuArtistIntf {

	public static final IMyxName msg = MyxUtils.createName("MenuArtist");
	public static final IMyxName txtmsg = MyxUtils.createName("Texture");

	TextureIntf tm;
	GL gl;
	TextRenderer texRen;
	Menu menu;
	
	public void setGL(GL g)
	{
		gl = g;
	}

	public void setTR(TextRenderer tr){
		texRen = tr;
	}
	
	public void setMenu(Menu m)
	{
		menu = m;
	}
	
	public void DrawMenu(int width, int height)
	{

		if (menu == null)
			return;
		//set text color before we draw
		texRen.setColor(1.0f, 1.0f, 0.0f, 1.0f);
		
		MenuItem[] items = menu.getMenuItems();
		Font f = menu.getFont();
		double pad, keyWidth;
		int x, y;
		String text;
		
		pad = menu.getPadding();
		keyWidth = menu.getKeyWidth();
		
		if (menu.getTitleAlign() == Menu.LEFT_ALIGN){
			x = (int)pad*width;
		}
		else if (menu.getTitleAlign() == Menu.RIGHT_ALIGN){
			x = (width-MyxGraphicsMaster.widthOfString(f, menu.getTitle()) - (int)(width*pad));
		}
		else { //Center the title by default
			x = (width-MyxGraphicsMaster.widthOfString(f, menu.getTitle()))/2;
		}
		y = (int)((1-pad)*height);
		texRen.beginRendering(width, height);
		texRen.draw(menu.getTitle(), x, y);
		for (int i = 0; i < items.length; i++){
			texRen.setColor(1.0f, 1.0f, 1.0f, 1.0f);
			text = "[" + items[i].getKey() + "]";
		
			if (items[i].getAlignment() == Menu.LEFT_ALIGN){
				x = (int)(pad*width);
			}
			else if (items[i].getAlignment() == Menu.RIGHT_ALIGN){
				x = (int)(width*(1-pad)) - MyxGraphicsMaster.widthOfString(f, text);
			}
			y = height - ((2*i + 6) * f.getSize());
			texRen.draw(text, x, y);
			text = items[i].getText();
			texRen.draw(text, (int)(width*(keyWidth+pad)), y);
		}
		texRen.endRendering();
		//gl.glEnable(GL.GL_CULL_FACE);		 
	}

	public void begin(){
		tm = (TextureIntf)MyxUtils.getFirstRequiredServiceObject(this, txtmsg);
	}

	public Object getServiceObject(IMyxName arg0) {
		// TODO Auto-generated method stub
		if (arg0.equals(msg)){
			return this;
		}
		return null;
	}
}
