package inf119.interfaces;

import inf119.LanderModel;
import inf119.LocOri;

import java.io.FileNotFoundException;
import java.io.IOException;

public interface PlayerDataIntf {
	
	public void loadShip(String filename, int localOfFuelInFile) throws FileNotFoundException, IOException;
	public void loadScenario(String filename) throws FileNotFoundException, IOException;
	public void updateScenarioNumbers(double[] currentStats);
	public void setUpFuelNumbers();
	public double[] getShipNumbers();
	public double[] getScenarioNumbers();
	public int getGameState();
	public void updateGameState(int state);
	public int getMenuState();
	public void updateMenuState(int state);
	public int getDifficultyLevel();
	public void setDifficultyLevel(int level);
	public double getInitialFuelPercent();
	public double getCurrentFuelLevelPercent();
	public double getMaxFuelLevel();
	public void updateCameraInfo(LocOri cam);
	public LocOri getCameraInfo();
	public void createLanderModel(String filename) throws FileNotFoundException, IOException;
	public LanderModel getLanderModel();
	public String getPlanetFileName();
	public String getShipName();
	public String getPictureFileName();
	public String getScenarioName();
	public void setThrusting(boolean thrust);
	public boolean getThrusting();
	
}
